uses Crt;

const HexDig : Array[0..15] of Char = '0123456789ABCDEF';
const BinDig : Array[0..1] of Char = '01';

type TMode = (HexDec, HexBin, DecHex, DecBin, BinHex, BinDec);

var
  Mode : TMode;
  Hex : String;
  Dec : String;
  Bin : String;
  Key : Char;


(*------------------------*)
(* IMPLEMENTATION         *)
(*------------------------*)


(* TRANSFORMS A NUMERIC VALUE INTO A STRING *)
function IntToStr (IntIn : LongInt) : String;
var
  StrOut : String;
begin
  Str(IntIn, StrOut);
  IntToStr := StrOut;
end;


(* TRANSFORMS A NUMERIC VALUE INTO A STRING *)
function StrToInt (StrIn : String) : LongInt;
var
  IntOut : LongInt;
  ValCode : Integer;
begin
  Val(StrIn, IntOut, ValCode);
  StrToInt := IntOut;
end;


(* TRANSFORMS A HEXADECIMAL STRING INTO A DECIMAL INTEGER *)
function Hex2Dec(HexIn : String) : LongInt;
var
  DecOut, Int : LongInt;
  I, I2 : Integer;
begin
  DecOut := 0;
  for I := length(HexIn) downto 1 do begin
    Key := HexIn[I];
    Key := UpCase(Key);
    Int := Pos(Key, HexDig) - 1;
    for I2 := 0 to length(HexIn) - I - 1 do Int := Int * 16;
    DecOut := DecOut + Int;
  end;
  Hex2Dec := DecOut;
end;


(* TRANSFORMS A DECIMAL INTEGER INTO A HEXADECIMAL STRING *)
function Dec2Hex(IntIn : LongInt) : String;
var
  HexOut : String;
  Int : LongInt;
begin
  HexOut := '';
  repeat
    Int := IntIn mod 16;
    HexOut := HexDig[Int] + HexOut;
    IntIn := IntIn div 16;
  until IntIn = 0;
  Dec2Hex := HexOut;
end;


(* TRANSFORMS A DECIMAL INTEGER INTO A BINARY STRING *)
function Dec2Bin(IntIn : LongInt) : String;
var
  BinOut : String;
  Int : LongInt;
begin
  BinOut := '';
  repeat
    Int := IntIn mod 2;
    BinOut := BinDig[Int] + BinOut;
    IntIn := IntIn div 2;
  until IntIn = 0;
  Dec2Bin := BinOut;
end;


(* TRANSFORMS A BINARY STRING INTO A DECIMAL INTEGER *)
function Bin2Dec(BinIn : String) : LongInt;
var
  DecOut, Int : LongInt;
  I, I2 : Integer;
begin
  DecOut := 0;
  for I := length(BinIn) downto 1 do begin
    Key := BinIn[I];
    Key := UpCase(Key);
    Int := Pos(Key, BinDig) - 1;
    for I2 := 0 to length(BinIn) - I - 1 do Int := Int * 2;
    DecOut := DecOut + Int;
  end;
  Bin2Dec := DecOut;
end;



(*-----------------------------*)
(* MAIN PROGRAM PART           *)
(*-----------------------------*)
BEGIN
(* CLEAR SCREEN *)
  ClrScr;

(*---- PUT STARTSCREEN ----*)
  Mode := HexDec;
(* SET CURSOR *)
  GoToXY(3,4);
(* TYPE MODE *)
  case Mode of
    HexDec : write('Hex -> Dec');
    HexBin : write('Hex -> Bin');
    DecHex : write('Dec -> Hex');
    DecBin : write('Dec -> Bin');
    BinHex : write('Bin -> Hex');
    BinDec : write('Bin -> Dec');
  end;
(* PUT INSTRUCTIONS *)
  GoToXY(26,4);
  Write('Select with UP and DOWN and choose with ENTER');


(*-- STARTING LOOP (SELECT MODE) --*)
  repeat
    Key := ReadKey;     (* KEY IS PRESSED KEY *)
    case key of
        (* KEY UP ARROW PRESSED *)
      chr(72) : if Mode <> BinDec then Mode := TMode(Integer(Mode)+1)
                else Mode := TMode(Integer(0));
      chr(80) : if Mode <> HexDec then Mode := TMode(Integer(Mode)-1)
                else Mode := TMode(Integer(5));
    end; (* case *)

      (* SET CURSOR *)
    GoToXY(3,4);
      (* TYPE MODE *)
    case Mode of
      HexDec : write('Hex -> Dec');
      HexBin : write('Hex -> Bin');
      DecHex : write('Dec -> Hex');
      DecBin : write('Dec -> Bin');
      BinHex : write('Bin -> Hex');
      BinDec : write('Bin -> Dec');
    end;

  until Key = chr(13);
(* LOOP ENDS IF ENTER PRESSED *)


(* PUT NEW LINE *)
      WriteLn('');

(* ? MODE *)
  case Mode of

(* HEX TO DEC *)
    HexDec : begin
      Write('Hexadecimal: ');
      (* GET THE HEXADECIMAL STRING *)
      ReadLn(Hex);
      (* PUT THE ANSWER *)
      WriteLn('Decimal: ' + IntToStr(Hex2Dec(Hex)));
    end;

(* DEC TO HEX *)
    DecHex : begin
      Write('Decimal: ');
      (* GET THE DECIMAL STRING *)
      ReadLn(Dec);
      (* PUT THE ANSWER *)
      WriteLn('Hexadecimal: ' + Dec2Hex(StrToInt(Dec)));
    end;

(* DEC TO BIN *)
    DecBin : begin
      Write('Decimal: ');
      (* GET THE DECIMAL STRING *)
      ReadLn(Dec);
      (* PUT THE ANSWER *)
      WriteLn('Binary: ' + Dec2Bin(StrToInt(Dec)));
    end;

(* BIN TO DEC *)
    BinDec : begin
      Write('Binary: ');
      (* GET THE BINARY STRING *)
      ReadLn(Bin);
      (* PUT THE ANSWER *);
      WriteLn('Decimal: ' + IntToStr(Bin2Dec(Bin)));
    end;

(* BIN TO HEX *)
    BinHex : begin
      Write('Binary: ');
      (* GET THE BINARY STRING *)
      ReadLn(Bin);
      (* PUT THE ANSWER *);
      WriteLn('Hexadecimal: ' + Dec2Hex(Bin2Dec(Bin)));
    end;

(* HEX TO BIN *)
    HexBin : begin
      Write('Hexadecimal: ');
      (* GET THE HEXADECIMAL STRING *)
      ReadLn(Hex);
      (* PUT THE ANSWER *)
      WriteLn('Binary: ' + Dec2Bin(Hex2Dec(Hex)));
    end;

  end;
  ReadLn;
END.